import { jsx as _jsx } from "react/jsx-runtime";
import { cloneElement, useState } from "react";
import CopyToClipboard from "react-copy-to-clipboard";
import { Tooltip } from "../Tooltip";
import "./styles.scss";
export var CopyText = function (_a) {
    var textToCopy = _a.textToCopy, _b = _a.variant, variant = _b === void 0 ? "inline" : _b, _c = _a.doneLabel, doneLabel = _c === void 0 ? "Copied" : _c, _d = _a.tooltipPlacement, tooltipPlacement = _d === void 0 ? "bottom" : _d, _e = _a.title, title = _e === void 0 ? "Copy" : _e, children = _a.children;
    var _f = useState(false), isTooltipVisible = _f[0], setIsTooltipVisible = _f[1];
    var handleCopyDone = function () {
        if (isTooltipVisible) {
            return;
        }
        setIsTooltipVisible(true);
        var t = setTimeout(function () {
            setIsTooltipVisible(false);
            clearTimeout(t);
        }, 1000);
    };
    if (variant === "headless") {
        return (_jsx(Tooltip, { isVisible: isTooltipVisible, triggerEl: _jsx(CopyToClipboard, { text: textToCopy, onCopy: handleCopyDone, children: cloneElement(children, {
                    title: title,
                }) }), placement: tooltipPlacement, children: doneLabel }));
    }
    if (variant === "ellipsis") {
        return (_jsx("div", { className: "CopyText CopyText--".concat(variant), children: _jsx(Tooltip, { isVisible: isTooltipVisible, triggerEl: _jsx(CopyToClipboard, { text: textToCopy, onCopy: handleCopyDone, children: _jsx("div", { title: title, role: "button", className: "CopyText__content", children: children }) }), placement: tooltipPlacement, children: doneLabel }) }));
    }
    return (_jsx("div", { className: "CopyText CopyText--".concat(variant), children: _jsx(Tooltip, { isVisible: isTooltipVisible, triggerEl: _jsx(CopyToClipboard, { text: textToCopy, onCopy: handleCopyDone, children: _jsx("div", { title: title, role: "button", className: "CopyText__content", children: children }) }), placement: tooltipPlacement, children: doneLabel }) }));
};
CopyText.displayName = "CopyText";
//# sourceMappingURL=index.js.map